using System.Reflection;
using HarmonyLib;
using Vintagestory.API.Client;
using Vintagestory.API.Common;
using Vintagestory.API.MathTools;
using Vintagestory.GameContent;

namespace MapAutocenter {
	public class MapAutocenterSystem: ModSystem {
		protected const string harmonyId = "mapautocenter";

		protected Harmony harmony;

		public override void StartClientSide(ICoreClientAPI capi) {
			base.StartClientSide(capi);

			this.harmony = new Harmony(harmonyId);
			harmony.PatchAll(Assembly.GetExecutingAssembly());
		}

		public override void Dispose() {
			base.Dispose();

			if(this.harmony != null) {
				this.harmony.UnpatchAll(harmonyId);
			}
		}
	}

	[HarmonyPatch(typeof(GuiDialogWorldMap), "OnGuiOpened")]
	public class MAC_GDWM_OnGuiOpened {
		static void Postfix(GuiDialogWorldMap __instance) {
			Traverse self = Traverse.Create(__instance);
			ICoreClientAPI capi = self.Field("capi").GetValue() as ICoreClientAPI;
			EnumDialogType dialogType = (EnumDialogType)self.Field("dialogType").GetValue();
			GuiComposer fullDialog = self.Field("fullDialog").GetValue() as GuiComposer;

			if(dialogType == EnumDialogType.Dialog) {
				GuiElementMap map = fullDialog.GetElement("mapElem") as GuiElementMap;
				if(map != null) {
					map.CenterMapTo(capi.World.Player.Entity.Pos.AsBlockPos);
					
					// Disable movement compensation.
					EntityPlayer player = capi.World.Player.Entity;
					if(player == null) {
						return;
					}

					Traverse gem = Traverse.Create(map);
					Vec3d prevPlayerPos = gem.Field("prevPlayerPos").GetValue() as Vec3d;
					prevPlayerPos.X = player.Pos.X;
					prevPlayerPos.Z = player.Pos.Z;
				}
			}
		}
	}
}